export declare const TIMPLA_PROCESS: {
    BABEL_ENV: string | undefined;
    INIT_CWD: string;
    IS_DEBUGGING: boolean;
    IS_LOCAL_TIMPLADEV: boolean;
    MEASURE: boolean;
    NODE_ENV: string;
    PROCESS_CWD: string;
    TIMPLA_CONFIG_FILE: string | undefined;
    TIMPLA_DEV_RELOAD: string | undefined;
    TIMPLA_DIR: string;
    isDevelopment: boolean;
    isProduction: boolean;
    isTimplaReloaded: boolean;
};
/** Useful constants such as IS_DEVELOPMENT, IS_PRODUCTION, INIT_CWD */
export declare type ITimplaProcess = typeof TIMPLA_PROCESS;
/**
 * A function that can be used to resolve a path relatively to the
 * project directory.
 *
 * We often want to resolve paths relatively to the project root
 * directory. To do that, we use the `INIT_CWD` environment variable
 * provided by Gulp. This variable always resolves to the project
 * root directory so we use it as the seed path and then add the
 * remaining arguments passed and resolving everything using the
 * `path.resolve` function.
 *
 * The returned path is a fully resolved absolute path relative to
 * the project root directory.
 */
export declare const projectPath: (...paths: (string | undefined)[]) => string;
/**
 * Checks if a package is installed.
 * Throws an error if it doesn't (forces the cli to exit).
 * Notifies the user, so that they can install missing deps!
 */
export declare const isPackageInstalled: (packageName: string) => boolean;
/** Checks if a package is installed, prompts if a package is missing */
export declare const lazyImport: (packageName: string) => any;
