import * as debug from 'debug';
/** DEBUG=timpla logger */
export declare const devLogger: debug.IDebugger;
/** Logs the given list of strings to the console. */
export declare const devLoggerTitle: (...args: any[]) => void;
/** Logs the given list of strings to the console. */
export declare const logTitle: (...args: any[]) => void;
export declare const pathToUrl: (...args: string[]) => string;
export declare const esWbformatter: ({ basePath }: any) => (results: any) => string;
/** Formatter for ForkTSCheckerWebpack */
export declare const tsWbformatter: (message: any) => string;
/**
 * Recursively combines two objects.
 * Nested arrays are merged as well.
 */
export declare const arrayMerge: (target: any, source: any, options: any) => any;
/**
 * Finds the first valid object from a list of arguments.
 */
export declare const getFirstValidObject: (...objs: any[]) => any;
/**
 * Handles gulp errors.
 */
export declare const handleErrors: (this: any, errorObject: any) => void;
/**
 * Adds displayNames to functions.
 * Useful for debugging.
 */
export declare const setDisplayName: (fun: any, name: string) => any;
/** Lazily imports packages */
export declare const sureLazyImport: any;
/** Checks if a folder is a child of the specified parent */
export declare const isChildOf: (child: string, parent: string) => boolean;
/**
 * Checks if gulp tasks exist.
 * If not, throws an error to notify the user to specify the right config.
 * Also sets the displayName for logging
 */
export declare const checkAndLabel: (fun: any, name: string) => void;
