"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var internal_1 = require("../internal");
exports.webpackManifest = function (jsDest, dest, filename) {
    filename = filename || 'rev-manifest.json';
    return function () {
        this.hooks.done.tap('webpackManifest', function (statsObject) {
            var stats = statsObject.toJson();
            var chunks = stats.assetsByChunkName;
            var manifest = {};
            for (var key in chunks) {
                if (chunks.hasOwnProperty(key)) {
                    var originalFilename = key + '.js';
                    // https://github.com/vigetlabs/blendid/issues/232#issuecomment-171963233
                    var chunkName = typeof chunks[key] === 'string' ? chunks[key] : chunks[key][0];
                    manifest[path.join(jsDest, originalFilename)] = path.join(jsDest, chunkName);
                }
            }
            fs.writeFileSync(internal_1.projectPath(dest, filename), JSON.stringify(manifest));
        });
    };
};
//# sourceMappingURL=webpackManifest.js.map