"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var browserSync = require("browser-sync");
var gulp = require("gulp");
var changed = require("gulp-changed");
var internal_1 = require("../internal");
exports.images = function (_a) {
    var imagesOptions = _a.images;
    return function (cb) {
        if (imagesOptions === false) {
            return cb;
        }
        var paths = {
            dest: internal_1.projectDestPath(imagesOptions.dest),
            src: internal_1.projectSrcPath(imagesOptions.src, "**/*.{" + imagesOptions.extensions + "}"),
        };
        return gulp
            .src(paths.src, imagesOptions.srcOptions)
            .pipe(changed(paths.dest)) // Ignore unchanged files
            .pipe(gulp.dest(paths.dest, imagesOptions.destOptions))
            .pipe(browserSync.stream());
    };
};
//# sourceMappingURL=images.js.map